diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/mpi/examples/simple-distributed-mpi-comm.cc ns-3.33/src/mpi/examples/simple-distributed-mpi-comm.cc
--- ns-3.32/src/mpi/examples/simple-distributed-mpi-comm.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.33/src/mpi/examples/simple-distributed-mpi-comm.cc	2021-01-09 10:19:22.000000000 -0800
@@ -0,0 +1,520 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ *  Copyright 2018. Lawrence Livermore National Security, LLC.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Steven Smith <smith84@llnl.gov>
+ */
+
+/**
+ * \file
+ * \ingroup mpi
+ *
+ * This test is equivalent to simple-distributed with the addition of 
+ * initialization of MPI by user code (this script) and providing
+ * a communicator to ns-3.  The ns-3 communicator is smaller than
+ * MPI Comm World as might be the case if ns-3 is run in parallel
+ * with another simulator.
+ *
+ * TestDistributed creates a dumbbell topology and logically splits it in
+ * half.  The left half is placed on logical processor 0 and the right half
+ * is placed on logical processor 1.
+ *
+ *                 -------   -------
+ *                  RANK 0    RANK 1
+ *                 ------- | -------
+ *                         |
+ * n0 ---------|           |           |---------- n6
+ *             |           |           |
+ * n1 -------\ |           |           | /------- n7
+ *            n4 ----------|---------- n5
+ * n2 -------/ |           |           | \------- n8
+ *             |           |           |
+ * n3 ---------|           |           |---------- n9
+ *
+ *
+ * OnOff clients are placed on each left leaf node. Each right leaf node
+ * is a packet sink for a left leaf node.  As a packet travels from one
+ * logical processor to another (the link between n4 and n5), MPI messages
+ * are passed containing the serialized packet. The message is then
+ * deserialized into a new packet and sent on as normal.
+ *
+ * One packet is sent from each left leaf node.  The packet sinks on the
+ * right leaf nodes output logging information when they receive the packet.
+ */
+
+#include "mpi-test-fixtures.h"
+
+#include "ns3/core-module.h"
+#include "ns3/network-module.h"
+#include "ns3/mpi-interface.h"
+#include "ns3/ipv4-global-routing-helper.h"
+#include "ns3/ipv4-static-routing-helper.h"
+#include "ns3/ipv4-list-routing-helper.h"
+#include "ns3/point-to-point-helper.h"
+#include "ns3/internet-stack-helper.h"
+#include "ns3/ipv4-nix-vector-helper.h"
+#include "ns3/ipv4-address-helper.h"
+#include "ns3/on-off-helper.h"
+#include "ns3/packet-sink.h"
+#include "ns3/packet-sink-helper.h"
+
+#include "mpi.h"
+
+using namespace ns3;
+
+NS_LOG_COMPONENT_DEFINE ("SimpleDistributedMpiComm");
+
+// Tag for whether this rank should go into a new communicator
+// ns-3 ranks will have color == 1.
+const int NS_COLOR = 1;
+const int NOT_NS_COLOR = NS_COLOR + 1;
+
+/**
+ * Report my rank, in both MPI_COMM_WORLD and the split communicator.
+ *
+ * \param [in] color My role, either ns-3 rank or other rank.
+ * \param [in] spitComm The split communicator.
+ */
+void
+ReportRank (int color, MPI_Comm splitComm)
+{
+  int otherId=0;
+  int otherSize=1;
+  
+  MPI_Comm_rank (splitComm, &otherId);
+  MPI_Comm_size (splitComm, &otherSize);
+  
+  if (color == NS_COLOR)
+    {
+      RANK0COUT ( "ns-3 rank:  ");
+    }
+  else
+    {
+      RANK0COUT ( "Other rank: ");
+    }
+  
+  RANK0COUTAPPEND ( "in MPI_COMM_WORLD: " << SinkTracer::GetWorldRank () << ":" << SinkTracer::GetWorldSize ()
+                    << ", in splitComm: "    << otherId   << ":" << otherSize
+                    << std::endl);
+  
+}  // ReportRank()
+
+int
+main (int argc, char *argv[])
+{
+  bool nix = true;
+  bool nullmsg = false;
+  bool tracing = false;
+  bool init = false;
+  bool verbose = false;
+  bool testing = false;
+
+  // Parse command line
+  CommandLine cmd;
+  cmd.AddValue ("nix", "Enable the use of nix-vector or global routing", nix);
+  cmd.AddValue ("nullmsg", "Enable the use of null-message synchronization (instead of granted time window)", nullmsg);
+  cmd.AddValue ("tracing", "Enable pcap tracing", tracing);
+  cmd.AddValue ("init", "ns-3 should initialize MPI by calling MPI_Init", init);
+  cmd.AddValue ("verbose", "verbose output", verbose);
+  cmd.AddValue ("test", "Enable regression test output", testing);
+  cmd.Parse (argc, argv);
+
+  // Defer reporting the configuration until we know the communicator
+  
+  // Distributed simulation setup; by default use granted time window algorithm.
+  if(nullmsg) 
+    {
+      GlobalValue::Bind ("SimulatorImplementationType",
+                         StringValue ("ns3::NullMessageSimulatorImpl"));
+    } 
+  else 
+    {
+      GlobalValue::Bind ("SimulatorImplementationType",
+                         StringValue ("ns3::DistributedSimulatorImpl"));
+    }
+
+  // MPI_Init
+
+  if (init)
+    {
+      // Initialize MPI directly
+      MPI_Init(&argc, &argv);
+    }
+  else
+    {
+      // Let ns-3 call MPI_Init and MPI_Finalize
+      MpiInterface::Enable (&argc, &argv);
+    }
+
+  SinkTracer::Init ();
+
+  auto worldSize = SinkTracer::GetWorldSize ();
+  auto worldRank = SinkTracer::GetWorldRank ();
+
+  if ( (!init) && (worldSize != 2))
+    {
+      RANK0COUT ("This simulation requires exactly 2 logical processors if --init is not set." << std::endl);
+      return 1;
+    }
+
+  if (worldSize < 2)
+    {
+      RANK0COUT ("This simulation requires 2  or more logical processors." << std::endl);
+      return 1;
+    }
+
+  // Set up the MPI communicator for ns-3
+  //  Condition                         ns-3 Communicator
+  //  a.  worldSize = 2    copy of MPI_COMM_WORLD
+  //  b.  worldSize > 2    communicator of ranks 1-2
+
+  // Flag to record that we created a communicator so we can free it at the end.
+  bool freeComm = false;  
+  // The new communicator, if we create one
+  MPI_Comm splitComm = MPI_COMM_WORLD;
+  // The list of ranks assigned to ns-3
+  std::string ns3Ranks;
+  // Tag for whether this rank should go into a new communicator
+  int color = MPI_UNDEFINED;
+
+
+  if (worldSize == 2)
+    {
+      std::stringstream ss;
+      color = NS_COLOR;
+      ss << "MPI_COMM_WORLD (" << worldSize << " ranks)";
+      ns3Ranks = ss.str ();
+      splitComm = MPI_COMM_WORLD;
+      freeComm = false;
+    }
+  else
+    {
+      //  worldSize > 2    communicator of ranks 1-2
+      
+      // Put ranks 1-2 in the new communicator
+      if (worldRank == 1 || worldRank == 2)
+        {
+          color = NS_COLOR;
+        }
+      else
+        {
+          color = NOT_NS_COLOR;
+        }
+      std::stringstream ss;
+      ss << "Split [1-2] (out of " << worldSize << " ranks) from MPI_COMM_WORLD";
+      ns3Ranks = ss.str ();
+      
+      // Now create the new communicator
+      MPI_Comm_split (MPI_COMM_WORLD, color, worldRank, &splitComm);
+      freeComm = true;
+    }
+
+
+  if(init)
+    {
+      MpiInterface::Enable (splitComm);
+    }
+
+  // Report the configuration from rank 0 only
+  RANK0COUT (cmd.GetName () << "\n");
+  RANK0COUT ("\n" );
+  RANK0COUT ("Configuration:\n" );
+  RANK0COUT ("Routing:           " << (nix ? "nix-vector" : "global") << "\n");
+  RANK0COUT ("Synchronization:   " << (nullmsg ? "null-message" : "granted time window (YAWNS)") << "\n");
+  RANK0COUT ("MPI_Init called:   " << (init ? "explicitly by this program" : "implicitly by ns3::MpiInterface::Enable()") << "\n" );
+  RANK0COUT ("ns-3 Communicator: " << ns3Ranks << "\n");
+  RANK0COUT ("PCAP tracing:      " << (tracing ? "" : "not") << " enabled\n");
+  RANK0COUT ("\n");
+  RANK0COUT ("Rank assignments:" << std::endl);
+
+  if (worldRank == 0)
+    {
+      ReportRank (color, splitComm);
+    }
+
+  if(verbose)
+    {
+      // Circulate a token to have each rank report in turn
+      int token;
+    
+      if (worldRank == 0)
+        {
+          token = 1;
+        }
+      else
+        {
+          MPI_Recv (&token, 1, MPI_INT, worldRank - 1, 0, MPI_COMM_WORLD, MPI_STATUS_IGNORE);
+          ReportRank (color, splitComm);
+        }
+
+      MPI_Send (&token, 1, MPI_INT, (worldRank + 1) % worldSize, 0, MPI_COMM_WORLD);
+
+      if (worldRank == 0)
+        {
+          MPI_Recv (&token, 1, MPI_INT, worldSize - 1, 0, MPI_COMM_WORLD, MPI_STATUS_IGNORE);
+        }
+    }  // circulate token to report rank
+
+  RANK0COUT (std::endl);
+
+  if (color != NS_COLOR)
+    {
+      // Do other work outside the ns-3 communicator
+      
+      // In real use of a separate communicator from ns-3
+      // the other tasks would be running another simulator
+      // or other desired work here..
+      
+      // Our work is done, just wait for everyone else to finish.
+
+      MpiInterface::Disable ();
+
+      if(init)
+        {
+          MPI_Finalize ();
+        }
+      
+      return 0;
+    }
+
+  // The code below here is essentially the same as simple-distributed.cc
+  // --------------------------------------------------------------------
+  
+  // We use a trace instead of relying on NS_LOG
+  
+  if (verbose)
+    {
+      LogComponentEnable ("PacketSink", LOG_LEVEL_INFO);
+    }
+
+  uint32_t systemId = MpiInterface::GetSystemId ();
+  uint32_t systemCount = MpiInterface::GetSize ();
+
+  // Check for valid distributed parameters.
+  // Both this script and simple-distributed.cc will work
+  // with arbitrary numbers of ranks, as long as there are at least 2.
+  if (systemCount < 2)
+    {
+      RANK0COUT ("This simulation requires at least 2 logical processors." << std::endl);
+      return 1;
+    }
+
+  // Some default values
+  Config::SetDefault ("ns3::OnOffApplication::PacketSize", UintegerValue (512));
+  Config::SetDefault ("ns3::OnOffApplication::DataRate", StringValue ("1Mbps"));
+  Config::SetDefault ("ns3::OnOffApplication::MaxBytes", UintegerValue (512));
+
+  // Create leaf nodes on left with system id 0
+  NodeContainer leftLeafNodes;
+  leftLeafNodes.Create (4, 0);
+
+  // Create router nodes.  Left router
+  // with system id 0, right router with
+  // system id 1
+  NodeContainer routerNodes;
+  Ptr<Node> routerNode1 = CreateObject<Node> (0);
+  Ptr<Node> routerNode2 = CreateObject<Node> (1);
+  routerNodes.Add (routerNode1);
+  routerNodes.Add (routerNode2);
+
+  // Create leaf nodes on left with system id 1
+  NodeContainer rightLeafNodes;
+  rightLeafNodes.Create (4, 1);
+
+  PointToPointHelper routerLink;
+  routerLink.SetDeviceAttribute ("DataRate", StringValue ("5Mbps"));
+  routerLink.SetChannelAttribute ("Delay", StringValue ("5ms"));
+
+  PointToPointHelper leafLink;
+  leafLink.SetDeviceAttribute ("DataRate", StringValue ("1Mbps"));
+  leafLink.SetChannelAttribute ("Delay", StringValue ("2ms"));
+
+  // Add link connecting routers
+  NetDeviceContainer routerDevices;
+  routerDevices = routerLink.Install (routerNodes);
+
+  // Add links for left side leaf nodes to left router
+  NetDeviceContainer leftRouterDevices;
+  NetDeviceContainer leftLeafDevices;
+  for (uint32_t i = 0; i < 4; ++i)
+    {
+      NetDeviceContainer temp = leafLink.Install (leftLeafNodes.Get (i), routerNodes.Get (0));
+      leftLeafDevices.Add (temp.Get (0));
+      leftRouterDevices.Add (temp.Get (1));
+    }
+
+  // Add links for right side leaf nodes to right router
+  NetDeviceContainer rightRouterDevices;
+  NetDeviceContainer rightLeafDevices;
+  for (uint32_t i = 0; i < 4; ++i)
+    {
+      NetDeviceContainer temp = leafLink.Install (rightLeafNodes.Get (i), routerNodes.Get (1));
+      rightLeafDevices.Add (temp.Get (0));
+      rightRouterDevices.Add (temp.Get (1));
+    }
+
+  InternetStackHelper stack;
+  Ipv4NixVectorHelper nixRouting;
+  Ipv4StaticRoutingHelper staticRouting;
+
+  Ipv4ListRoutingHelper list;
+  list.Add (staticRouting, 0);
+  list.Add (nixRouting, 10);
+
+  if (nix)
+    {
+      stack.SetRoutingHelper (list); // has effect on the next Install ()
+    }
+
+  stack.InstallAll ();
+
+  Ipv4InterfaceContainer routerInterfaces;
+  Ipv4InterfaceContainer leftLeafInterfaces;
+  Ipv4InterfaceContainer leftRouterInterfaces;
+  Ipv4InterfaceContainer rightLeafInterfaces;
+  Ipv4InterfaceContainer rightRouterInterfaces;
+
+  Ipv4AddressHelper leftAddress;
+  leftAddress.SetBase ("10.1.1.0", "255.255.255.0");
+
+  Ipv4AddressHelper routerAddress;
+  routerAddress.SetBase ("10.2.1.0", "255.255.255.0");
+
+  Ipv4AddressHelper rightAddress;
+  rightAddress.SetBase ("10.3.1.0", "255.255.255.0");
+
+  // Router-to-Router interfaces
+  routerInterfaces = routerAddress.Assign (routerDevices);
+
+  // Left interfaces
+  for (uint32_t i = 0; i < 4; ++i)
+    {
+      NetDeviceContainer ndc;
+      ndc.Add (leftLeafDevices.Get (i));
+      ndc.Add (leftRouterDevices.Get (i));
+      Ipv4InterfaceContainer ifc = leftAddress.Assign (ndc);
+      leftLeafInterfaces.Add (ifc.Get (0));
+      leftRouterInterfaces.Add (ifc.Get (1));
+      leftAddress.NewNetwork ();
+    }
+
+  // Right interfaces
+  for (uint32_t i = 0; i < 4; ++i)
+    {
+      NetDeviceContainer ndc;
+      ndc.Add (rightLeafDevices.Get (i));
+      ndc.Add (rightRouterDevices.Get (i));
+      Ipv4InterfaceContainer ifc = rightAddress.Assign (ndc);
+      rightLeafInterfaces.Add (ifc.Get (0));
+      rightRouterInterfaces.Add (ifc.Get (1));
+      rightAddress.NewNetwork ();
+    }
+
+  if (!nix)
+    {
+      Ipv4GlobalRoutingHelper::PopulateRoutingTables ();
+    }
+
+  if (tracing == true)
+    {
+      if (systemId == 0)
+        {
+          routerLink.EnablePcap("router-left", routerDevices, true);
+          leafLink.EnablePcap("leaf-left", leftLeafDevices, true);
+        }
+      
+      if (systemId == 1)
+        {
+          routerLink.EnablePcap("router-right", routerDevices, true);
+          leafLink.EnablePcap("leaf-right", rightLeafDevices, true);
+        }
+    }
+
+  // Create a packet sink on the right leafs to receive packets from left leafs
+  uint16_t port = 50000;
+  if (systemId == 1)
+    {
+      Address sinkLocalAddress (InetSocketAddress (Ipv4Address::GetAny (), port));
+      PacketSinkHelper sinkHelper ("ns3::UdpSocketFactory", sinkLocalAddress);
+      ApplicationContainer sinkApp;
+      for (uint32_t i = 0; i < 4; ++i)
+        {
+          auto apps = sinkHelper.Install (rightLeafNodes.Get (i));
+          auto sink = DynamicCast<PacketSink> (apps.Get (0));
+          NS_ASSERT_MSG (sink, "Couldn't get PacketSink application.");
+          if (testing)
+            {
+              sink->TraceConnectWithoutContext ("RxWithAddresses",  MakeCallback(&SinkTracer::SinkTrace));
+            }
+          sinkApp.Add (apps);
+        }
+      sinkApp.Start (Seconds (1.0));
+      sinkApp.Stop (Seconds (5));
+    }
+
+  // Create the OnOff applications to send
+  if (systemId == 0)
+    {
+      OnOffHelper clientHelper ("ns3::UdpSocketFactory", Address ());
+      clientHelper.SetAttribute
+        ("OnTime", StringValue ("ns3::ConstantRandomVariable[Constant=1]"));
+      clientHelper.SetAttribute
+        ("OffTime", StringValue ("ns3::ConstantRandomVariable[Constant=0]"));
+
+      ApplicationContainer clientApps;
+      for (uint32_t i = 0; i < 4; ++i)
+        {
+          AddressValue remoteAddress
+            (InetSocketAddress (rightLeafInterfaces.GetAddress (i), port));
+          clientHelper.SetAttribute ("Remote", remoteAddress);
+          clientApps.Add (clientHelper.Install (leftLeafNodes.Get (i)));
+        }
+      clientApps.Start (Seconds (1.0));
+      clientApps.Stop (Seconds (5));
+    }
+
+  RANK0COUT (std::endl);
+
+  Simulator::Stop (Seconds (5));
+  Simulator::Run ();
+  Simulator::Destroy ();
+
+  // --------------------------------------------------------------------
+  // Conditional cleanup based on whether we built a communicator
+  // and called MPI_Init
+  
+  if (freeComm)
+    {
+      MPI_Comm_free (&splitComm);
+    }
+
+  if (testing)
+    {
+      SinkTracer::Verify (4);
+    }
+  
+  // Clean up the ns-3 MPI execution environment
+  // This will call MPI_Finalize if MpiInterface::Initialize was called
+  MpiInterface::Disable ();
+
+  if (init)
+    {
+      // We called MPI_Init, so we have to call MPI_Finalize
+      MPI_Finalize ();
+    }
+  
+  return 0;
+}
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/mpi/examples/third-distributed.cc ns-3.33/src/mpi/examples/third-distributed.cc
--- ns-3.32/src/mpi/examples/third-distributed.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/mpi/examples/third-distributed.cc	2021-01-09 10:19:22.000000000 -0800
@@ -14,6 +14,8 @@
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  */
 
+#include "mpi-test-fixtures.h"
+
 #include "ns3/core-module.h"
 #include "ns3/point-to-point-module.h"
 #include "ns3/network-module.h"
@@ -25,21 +27,30 @@
 #include "ns3/yans-wifi-helper.h"
 #include "ns3/ssid.h"
 
-// Default Network Topology
-//
-// (same as third.cc from tutorial)
-// Distributed simulation, split across the p2p link
-//                          |
-//                 Rank 0   |   Rank 1
-// -------------------------|----------------------------
-//   Wifi 10.1.3.0
-//                 AP
-//  *    *    *    *
-//  |    |    |    |    10.1.1.0
-// n5   n6   n7   n0 -------------- n1   n2   n3   n4
-//                   point-to-point  |    |    |    |
-//                                   ================
-//                                     LAN 10.1.2.0
+#include <iomanip>
+
+/**
+ * \file
+ * \ingroup mpi
+ *
+ * Distributed version of third.cc from the tutorial.
+ *
+ *  Default Network Topology
+ *
+ * (same as third.cc from tutorial)
+ * Distributed simulation, split across the p2p link
+ *                          |
+ *                 Rank 0   |   Rank 1
+ * -------------------------|----------------------------
+ *   Wifi 10.1.3.0
+ *                 AP
+ *  *    *    *    *
+ *  |    |    |    |    10.1.1.0
+ * n5   n6   n7   n0 -------------- n1   n2   n3   n4
+ *                   point-to-point  |    |    |    |
+ *                                   ================
+ *                                    LAN 10.1.2.0
+ */
 
 using namespace ns3;
 
@@ -48,11 +59,12 @@
 int 
 main (int argc, char *argv[])
 {
-  bool verbose = true;
+  bool verbose = false;
   uint32_t nCsma = 3;
   uint32_t nWifi = 3;
   bool tracing = false;
   bool nullmsg = false;
+  bool testing = false;
 
   CommandLine cmd (__FILE__);
   cmd.AddValue ("nCsma", "Number of \"extra\" CSMA nodes/devices", nCsma);
@@ -60,6 +72,7 @@
   cmd.AddValue ("verbose", "Tell echo applications to log if true", verbose);
   cmd.AddValue ("tracing", "Enable pcap tracing", tracing);
   cmd.AddValue ("nullmsg", "Enable the use of null-message synchronization", nullmsg);
+  cmd.AddValue ("test", "Enable regression test output", testing);
 
   cmd.Parse (argc,argv);
 
@@ -74,8 +87,8 @@
 
   if (verbose)
     {
-      LogComponentEnable ("UdpEchoClientApplication", LOG_LEVEL_INFO);
-      LogComponentEnable ("UdpEchoServerApplication", LOG_LEVEL_INFO);
+      LogComponentEnable ("UdpEchoClientApplication", (LogLevel)(LOG_LEVEL_INFO | LOG_PREFIX_NODE | LOG_PREFIX_TIME));
+      LogComponentEnable ("UdpEchoServerApplication", (LogLevel)(LOG_LEVEL_INFO | LOG_PREFIX_NODE | LOG_PREFIX_TIME));
     }
 
   // Sequential fallback values
@@ -96,6 +109,8 @@
 
   MpiInterface::Enable (&argc, &argv);
 
+  SinkTracer::Init ();
+
   systemId = MpiInterface::GetSystemId ();
   systemCount = MpiInterface::GetSize ();
 
@@ -145,7 +160,7 @@
   NodeContainer wifiApNode = p2pNodes.Get (0);
 
   YansWifiChannelHelper channel = YansWifiChannelHelper::Default ();
-  YansWifiPhyHelper phy = YansWifiPhyHelper::Default ();
+  YansWifiPhyHelper phy;
   phy.SetChannel (channel.Create ());
 
   WifiHelper wifi;
@@ -212,6 +227,11 @@
       ApplicationContainer serverApps = echoServer.Install (csmaNodes.Get (nCsma));
       serverApps.Start (Seconds (1.0));
       serverApps.Stop (Seconds (10.0));
+
+      if (testing)
+        {
+          serverApps.Get (0)->TraceConnectWithoutContext ("RxWithAddresses", MakeCallback (&SinkTracer::SinkTrace));
+        }
     }
 
   // If this rank is systemWifi
@@ -228,6 +248,11 @@
         echoClient.Install (wifiStaNodes.Get (nWifi - 1));
       clientApps.Start (Seconds (2.0));
       clientApps.Stop (Seconds (10.0));
+
+      if (testing)
+        {
+          clientApps.Get (0)->TraceConnectWithoutContext ("RxWithAddresses", MakeCallback (&SinkTracer::SinkTrace));
+        }
     }
  
   Ipv4GlobalRoutingHelper::PopulateRoutingTables ();
@@ -258,6 +283,11 @@
   Simulator::Run ();
   Simulator::Destroy ();
 
+  if (testing)
+    {
+      SinkTracer::Verify (2);
+    }
+
   // Exit the MPI execution environment
   MpiInterface::Disable ();
   
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/mpi/examples/wscript ns-3.33/src/mpi/examples/wscript
--- ns-3.32/src/mpi/examples/wscript	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/mpi/examples/wscript	2021-01-09 10:19:22.000000000 -0800
@@ -3,16 +3,23 @@
 def build(bld):
     obj = bld.create_ns3_program('simple-distributed',
                                  ['mpi', 'point-to-point', 'internet', 'nix-vector-routing', 'applications'])
-    obj.source = 'simple-distributed.cc'
+    obj.source = ['simple-distributed.cc', 'mpi-test-fixtures.cc']
+    
+    obj = bld.create_ns3_program('simple-distributed-empty-node',
+                                 ['mpi', 'point-to-point', 'internet', 'nix-vector-routing', 'applications'])
+    obj.source = ['simple-distributed-empty-node.cc', 'mpi-test-fixtures.cc']
+
+    obj = bld.create_ns3_program('simple-distributed-mpi-comm',
+                                 ['point-to-point', 'internet', 'nix-vector-routing', 'applications'])
+    obj.source = ['simple-distributed-mpi-comm.cc', 'mpi-test-fixtures.cc']
 
     obj = bld.create_ns3_program('third-distributed',
                                  ['mpi', 'point-to-point', 'internet', 'mobility', 'wifi', 'csma', 'applications'])
-    obj.source = 'third-distributed.cc'
+    obj.source = ['third-distributed.cc', 'mpi-test-fixtures.cc']
 
     obj = bld.create_ns3_program('nms-p2p-nix-distributed',
                                  ['mpi', 'point-to-point', 'internet', 'nix-vector-routing', 'applications'])
-    obj.source = 'nms-p2p-nix-distributed.cc'
+    obj.source = ['nms-p2p-nix-distributed.cc', 'mpi-test-fixtures.cc']
+
+
 
-    obj = bld.create_ns3_program('simple-distributed-empty-node',
-                                 ['mpi', 'point-to-point', 'internet', 'nix-vector-routing', 'applications'])
-    obj.source = 'simple-distributed-empty-node.cc'
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/mpi/model/distributed-simulator-impl.cc ns-3.33/src/mpi/model/distributed-simulator-impl.cc
--- ns-3.32/src/mpi/model/distributed-simulator-impl.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/mpi/model/distributed-simulator-impl.cc	2021-01-09 10:19:22.000000000 -0800
@@ -17,6 +17,12 @@
  *
  */
 
+/**
+ * \file
+ * \ingroup mpi
+ *  Implementation of classes  ns3::LbtsMessage and ns3::DistributedSimulatorImpl.
+ */
+
 #include "distributed-simulator-impl.h"
 #include "granted-time-window-mpi-interface.h"
 #include "mpi-interface.h"
@@ -73,7 +79,12 @@
   return m_isFinished;
 }
 
-Time DistributedSimulatorImpl::m_lookAhead = Seconds (-1);
+/**
+ * Initialize m_lookAhead to maximum, it will be constrained by
+ * user supplied time via BoundLookAhead and the
+ * minimum latency network between ranks.
+ */
+Time DistributedSimulatorImpl::m_lookAhead = Time::Max();
 
 TypeId
 DistributedSimulatorImpl::GetTypeId (void)
@@ -158,18 +169,13 @@
 {
   NS_LOG_FUNCTION (this);
 
+  /* If runnning sequential simulation can ignore lookahead */
   if (MpiInterface::GetSize () <= 1)
     {
       m_lookAhead = Seconds (0);
     }
   else
     {
-      if (m_lookAhead == Seconds (-1))
-        {
-          m_lookAhead = GetMaximumSimulationTime ();
-        }
-      // else it was already set by SetLookAhead
-
       NodeContainer c = NodeContainer::GetGlobal ();
       for (NodeContainer::Iterator iter = c.Begin (); iter != c.End (); ++iter)
         {
@@ -254,7 +260,7 @@
       sendbuf  = m_lookAhead.GetInteger ();
     }
 
-  MPI_Allreduce (&sendbuf, &recvbuf, 1, MPI_LONG, MPI_MAX, MPI_COMM_WORLD);
+  MPI_Allreduce (&sendbuf, &recvbuf, 1, MPI_LONG, MPI_MAX, MpiInterface::GetCommunicator ());
 
   /* For nodes that did not compute a lookahead use max from ranks
    * that did compute a value.  An edge case occurs if all nodes have
@@ -270,16 +276,16 @@
 }
 
 void
-DistributedSimulatorImpl::SetMaximumLookAhead (const Time lookAhead)
+DistributedSimulatorImpl::BoundLookAhead (const Time lookAhead)
 {
   if (lookAhead > Time (0))
     {
       NS_LOG_FUNCTION (this << lookAhead);
-      m_lookAhead = lookAhead;
+      m_lookAhead = Min(m_lookAhead, lookAhead);
     }
   else
     {
-      NS_LOG_WARN ("attempted to set look ahead negative: " << lookAhead);
+      NS_LOG_WARN ("attempted to set lookahead to a negative time: " << lookAhead);
     }
 }
 
@@ -385,7 +391,7 @@
                             m_myId, IsLocalFinished (), nextTime);
           m_pLBTS[m_myId] = lMsg;
           MPI_Allgather (&lMsg, sizeof (LbtsMessage), MPI_BYTE, m_pLBTS,
-                         sizeof (LbtsMessage), MPI_BYTE, MPI_COMM_WORLD);
+                         sizeof (LbtsMessage), MPI_BYTE, MpiInterface::GetCommunicator ());
           Time smallestTime = m_pLBTS[0].GetSmallestTime ();
           // The totRx and totTx counts insure there are no transient
           // messages;  If totRx != totTx, there are transients,
@@ -404,6 +410,11 @@
               totTx += m_pLBTS[i].GetTxCount ();
               m_globalFinished &= m_pLBTS[i].IsFinished ();
             }
+
+          // Global halting condition is all nodes have empty queue's and
+          // no messages are in-flight.
+          m_globalFinished &= totRx == totTx;
+          
           if (totRx == totTx)
             {
               // If lookahead is infinite then granted time should be as well.
